/*
 * Created on Jul 28, 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package asr.web;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.InputStreamReader;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;

import com.mysql.jdbc.Connection;
import com.mysql.jdbc.PreparedStatement;
import com.mysql.jdbc.ResultSet;

import asr.web.db.ConnectionPoolCtrl;

public class ForumCtrl {

	private final String DBName = "asr_db";
	private static ForumCtrl instance; // 포럼 컨트롤 클래스의 유일한 인스턴스

	public static ForumCtrl getInstance() {
		if (instance == null) {
			instance = new ForumCtrl();
		}

		return instance;
	}

	//DB에서 포스트의 내용을 가져옴(특정 게시물을 볼때)
	public ForumPostBean getPost(int p_id) throws ForumCtrl_Exception {
		ConnectionPoolCtrl dbCtrl = ConnectionPoolCtrl.getInstance();

		Connection conn = null;
		Statement stmt = null;
		ResultSet rs = null;

		ForumPostBean postBean = null; // 리턴할 ForumPostBean

		try {
			conn = (Connection) dbCtrl.getConnection(DBName); // DB.cfg 파일의
			// 변수(?)명
			stmt = conn.createStatement();
			// 테이블에서 특정 주제를 읽어 온다.
			rs = (ResultSet) stmt
					.executeQuery("select * from forum_post where p_id="
							+ p_id);

			BufferedReader br = null;
			StringBuffer sBuffer = new StringBuffer(512);
			if (rs.next()) {
				postBean = new ForumPostBean();
				br = new BufferedReader(new InputStreamReader(rs
						.getAsciiStream("content")));
				while (br.ready()) {
					sBuffer.append(br.readLine()).append("\r\n");
				}
				br.close();
				br = null;

				// ForumPostBean 컴포넌트에서 읽어온 내용을 저장
				postBean.setP_id(rs.getInt("p_id"));
				postBean.setName(rs.getString("name"));
				postBean.setEmail(rs.getString("email"));
				postBean.setPasswd(rs.getString("passwd"));
				postBean.setSubject(rs.getString("subject"));
				//postBean.setSubject(rs.getString("content"));
				postBean.setContent(sBuffer.toString());
				postBean.setW_time(rs.getTimestamp("w_time"));
				postBean.setW_ip(rs.getString("w_ip"));
				postBean.setConn_postcnt(rs.getInt("conn_postcnt"));
			}
			rs.close();
		} catch (Exception e) {
			//System.err.println("Message :: ForumCtrl.java: getPost(int)");
			throw new ForumCtrl_Exception(ForumCtrl_Exception.GET_TITLE,
					"포럼 주제를 읽어오는 과정에서 예외 발생");
		} finally {
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException e) {
					System.err
							.println("Exception :: ForumCtrl.java: getPost(int): stmt.close() 실행중 예외발생");
				}
			}

			if (conn != null) {
				dbCtrl.returnConnection(DBName, conn);
			}
		}
		return postBean;
	}

	//리스트
	public ForumPostBean[] getPostList() throws ForumCtrl_Exception {
		ConnectionPoolCtrl dbCtrl = ConnectionPoolCtrl.getInstance();
		Connection conn = null;
		Statement stmt = null;
		ResultSet rs = null;

		Vector result = new Vector(); // 리턴할 내용을 임시로 저장
		try {
			conn = (Connection) dbCtrl.getConnection(DBName);
			stmt = conn.createStatement();
			rs = (ResultSet) stmt
					.executeQuery("select p_id, name, subject, conn_postcnt, w_time from forum_post order by p_id desc");
			ForumPostBean postBean = null;

			while (rs.next()) {
				// ForumPostBean 에 목록 관련 내용 저장
				postBean = new ForumPostBean();
				postBean.setP_id(rs.getInt("p_id"));
				postBean.setName(rs.getString("name"));
				postBean.setSubject(rs.getString("subject"));
				postBean.setConn_postcnt(rs.getInt("conn_postcnt"));
				postBean.setW_time(rs.getTimestamp("w_time"));
				//postBean.setSubject(rs.getString("content"));
				result.addElement(postBean);
			}

			rs.close();
		} catch (SQLException e) {
			e.printStackTrace();
			throw new ForumCtrl_Exception(ForumCtrl_Exception.GET_TITLE_LIST,
					"포럼 주제 목록을 읽어오는 과정에서 예외 발생");
			//System.err.println("Exception :: ForumCtrl.java: getPostList(): 실행중 예외발생");

		} finally {
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException e) {
					System.err
							.println("Exception :: ForumCtrl.java: getPostList(): stmt.close() 실행중 예외발생");
				}
			}

			if (conn != null) {
				dbCtrl.returnConnection(DBName, conn);
			}
		}
		// Vector에 저장된 내용을 ForumPostBean[] 에 저장한다.
		ForumPostBean[] resultArray = new ForumPostBean[result.size()];

		for (int i = 0; i < resultArray.length; i++) {
			resultArray[i] = (ForumPostBean) result.elementAt(i);
		}
		return resultArray;
	}

	//새로운 포스팅
	public void appendPost(ForumPostBean newPost) throws ForumCtrl_Exception {
		if (newPost == null) {
			throw new IllegalArgumentException("argument cant be null");
		}
		ConnectionPoolCtrl dbCtrl = ConnectionPoolCtrl.getInstance();
		Connection conn = null;
		Statement stmt = null;
		ResultSet rs = null;
		PreparedStatement pstmt = null;

		try {
			conn = (Connection) dbCtrl.getConnection(DBName);
			stmt = conn.createStatement();
			// 가장 마지막 주제의 p_id번호를 구한다.
			rs = (ResultSet) stmt
					.executeQuery("select max(p_id) from forum_post");
			int maxNum = 0;
			if (rs.next()) {
				maxNum = rs.getInt(1);
			}
			rs.close();
			newPost.setP_id(++maxNum);

			pstmt = (PreparedStatement) conn
					.prepareStatement("insert into forum_post (p_id, name, email, passwd, subject, content, w_ip, conn_postcnt) values (?,?,?,?,?,?,?,?)");
			byte[] contentArray = newPost.getContent().getBytes();
			ByteArrayInputStream is = new ByteArrayInputStream(contentArray);
			int size = contentArray.length;

			pstmt.setInt(1, newPost.getP_id());
			pstmt.setString(2, newPost.getName());
			pstmt.setString(3, newPost.getEmail());
			pstmt.setString(4, newPost.getPasswd());
			pstmt.setString(5, newPost.getSubject());
			pstmt.setAsciiStream(6, is, size);
			pstmt.setString(7, newPost.getW_ip());
			pstmt.setInt(8, 0);
			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			throw new ForumCtrl_Exception(ForumCtrl_Exception.APPEND_TITLE,
					"주제를 추가하는 과정에서 예외 발생");

		} finally {
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException e) {
					System.err
							.println("Exception :: ForumCtrl.java: appendPost(ForumPostBean): stmt.close() 실행중 예외발생");
				}
			}

			if (pstmt != null) {
				try {
					pstmt.close();
				} catch (SQLException e) {
					System.err
							.println("Exception :: ForumCtrl.java: appendPost(ForumPostBean): pstmt.close() 실행중 예외발생");
				}
			}

			if (conn != null) {
				dbCtrl.returnConnection(DBName, conn);
			}
		}
	}

//	//포스팅된 주제에 관련된 리플 수를 얻어옴
//	public int getContentCount(int post_idx) throws ForumCtrl_Exception {
//		ConnectionPoolCtrl dbCtrl = ConnectionPoolCtrl.getInstance();
//		Connection conn = null;
//		Statement stmt = null;
//		ResultSet rs = null;
//
//		int count = 0; // 관련 주제의 글 갯수를 저장한다.
//
//		try {
//			conn = (Connection) dbCtrl.getConnection(DBName);
//			stmt = conn.createStatement();
//			rs = (ResultSet) stmt
//					.executeQuery("select count(*) from forum_reply where post_idx="
//							+ post_idx);
//
//			if (rs.next()) {
//				count = rs.getInt(1);
//			}
//			rs.close();
//
//		} catch (SQLException e) {
//			e.printStackTrace();
//			throw new ForumCtrl_Exception(ForumCtrl_Exception.CONTENT_COUNT,
//					"주제의 글 갯수를 읽어오는 과정에서 예외 발생");
//		} finally {
//			if (stmt != null) {
//				try {
//					stmt.close();
//				} catch (SQLException e) {
//					System.err
//							.println("Exception :: ForumCtrl.java: getContentCount(int): pstmt.close() 실행중 예외발생");
//				}
//			}
//
//			if (conn != null) {
//				dbCtrl.returnConnection(DBName, conn);
//			}
//		}
//		return count;
//	}

	//포스팅된 주제에 관련된 리플들을 가져옴
	public ForumReplyBean[] getReplyList(int post_idx) throws ForumCtrl_Exception {
		ConnectionPoolCtrl dbCtrl = ConnectionPoolCtrl.getInstance();
		Connection conn = null;
		Statement stmt = null;
		ResultSet rs = null;
		Vector result = new Vector();

		try {
			conn = (Connection) dbCtrl.getConnection(DBName);
			stmt = conn.createStatement();
			// 나중에 쿼리 손봐야 함. 일정 순번(p_id)부터 몇개(갯수) 를 뽑아오는 방법으로 수정해야 함.
			rs = (ResultSet) stmt
					.executeQuery("select * from forum_reply where post_idx="
							+ post_idx + " order by reply_order desc");

			ForumReplyBean replyBean = null;
			StringBuffer sBuffer = new StringBuffer(512);
			BufferedReader br = null;

			while (rs.next()) {
				replyBean = new ForumReplyBean();
				br = new BufferedReader(new InputStreamReader(rs
						.getAsciiStream("content")));
				while (br.ready()) {
					sBuffer.append(br.readLine()).append("\r\n");
				}
				br.close();
				br = null;

				replyBean.setP_id(rs.getInt("p_id"));
				replyBean.setPost_idx(rs.getInt("post_idx"));
				replyBean.setName(rs.getString("name"));
				replyBean.setEmail(rs.getString("email"));
				replyBean.setPasswd(rs.getString("passwd"));
				replyBean.setReply_order(rs.getInt("reply_order"));
				replyBean.setContent(sBuffer.toString());
				replyBean.setW_time(rs.getTimestamp("w_time"));
				replyBean.setW_ip(rs.getString("w_ip"));
				result.addElement(replyBean);
				sBuffer.delete(0, sBuffer.length() - 1);
			}
		} catch (Exception e) {
			e.printStackTrace();
			throw new ForumCtrl_Exception(ForumCtrl_Exception.GET_CONTENT,
					"포럼 내용을 읽어오는 과정에서 예외 발생");
		} finally {
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException e) {
					System.err
							.println("Exception :: ForumCtrl.java: getReplyList(int): stmt.close() 실행중 예외발생");
				}

				if (conn != null) {
					dbCtrl.returnConnection(DBName, conn);
				}
			}
		}

		ForumReplyBean[] resultArray = new ForumReplyBean[result.size()];

		for (int i = 0; i < resultArray.length; i++) {
			resultArray[i] = (ForumReplyBean) result.elementAt(i);
		}

		return resultArray;
	}
	
//	//포스팅된 주제에 관련된 리플들을 가져옴(시작, 끝 번호 사이의 리플만 가져옴)
//	public ForumReplyBean[] getReplyList(int post_idx, int startOrder,
//			int endOrder) throws ForumCtrl_Exception {
//		ConnectionPoolCtrl dbCtrl = ConnectionPoolCtrl.getInstance();
//		Connection conn = null;
//		Statement stmt = null;
//		ResultSet rs = null;
//		Vector result = new Vector();
//
//		try {
//			conn = (Connection) dbCtrl.getConnection(DBName);
//			stmt = conn.createStatement();
//			// 나중에 쿼리 손봐야 함. 일정 순번(p_id)부터 몇개(갯수) 를 뽑아오는 방법으로 수정해야 함.
//			rs = (ResultSet) stmt
//					.executeQuery("select * from forum_reply where post_idx="
//							+ post_idx + "and reply_order>=" + startOrder
//							+ " and reply_order<=" + endOrder
//							+ " order by reply_order desc");
//
//			ForumReplyBean replyBean = null;
//			StringBuffer sBuffer = new StringBuffer(512);
//			BufferedReader br = null;
//
//			while (rs.next()) {
//				replyBean = new ForumReplyBean();
//				br = new BufferedReader(new InputStreamReader(rs
//						.getAsciiStream("content")));
//				while (br.ready()) {
//					sBuffer.append(br.readLine()).append("\r\n");
//				}
//				br.close();
//				br = null;
//
//				replyBean.setP_id(rs.getInt("p_id"));
//				replyBean.setPost_idx(rs.getInt("post_idx"));
//				replyBean.setName(rs.getString("name"));
//				replyBean.setEmail(rs.getString("email"));
//				replyBean.setPasswd(rs.getString("passwd"));
//				replyBean.setReply_order(rs.getInt("reply_order"));
//				replyBean.setContent(sBuffer.toString());
//				replyBean.setW_time(rs.getTimestamp("w_time"));
//				replyBean.setW_ip(rs.getString("w_ip"));
//				result.addElement(replyBean);
//				sBuffer.delete(0, sBuffer.length() - 1);
//			}
//		} catch (Exception e) {
//			e.printStackTrace();
//			throw new ForumCtrl_Exception(ForumCtrl_Exception.GET_CONTENT,
//					"포럼 내용을 읽어오는 과정에서 예외 발생");
//		} finally {
//			if (stmt != null) {
//				try {
//					stmt.close();
//				} catch (SQLException e) {
//					System.err
//							.println("Exception :: ForumCtrl.java: getReplyList(int, int, int): stmt.close() 실행중 예외발생");
//				}
//
//				if (conn != null) {
//					dbCtrl.returnConnection(DBName, conn);
//				}
//			}
//		}
//
//		ForumReplyBean[] resultArray = new ForumReplyBean[result.size()];
//
//		for (int i = 0; i < resultArray.length; i++) {
//			resultArray[i] = (ForumReplyBean) result.elementAt(i);
//		}
//
//		return resultArray;
//	}

	//리플을 DB에 저장
	public synchronized void writeReply(ForumReplyBean reply)
			throws ForumCtrl_Exception {
		ConnectionPoolCtrl dbCtrl = ConnectionPoolCtrl.getInstance();
		Connection conn = null;
		Statement stmt = null;
		ResultSet rs = null;
		PreparedStatement pstmt = null;

		try {
			conn = (Connection) dbCtrl.getConnection(DBName);
			stmt = conn.createStatement();
			rs = (ResultSet) stmt
					.executeQuery("select max(reply_order) from forum_reply where post_idx="
							+ reply.getPost_idx());

			if (rs.next()) {
				reply.setP_id(rs.getInt(1) + 1);
			}

			rs.close();

			pstmt = (PreparedStatement) conn
					.prepareStatement("insert into forum_reply (post_idx, name, email, passwd, reply_order, content, w_ip) values(?,?,?,?,?,?,?)");
			byte[] replyArray = reply.getContent().getBytes();
			ByteArrayInputStream is = new ByteArrayInputStream(replyArray);
			int size = replyArray.length;

			// pstmt.setInt(1, reply.getP_id());
			pstmt.setInt(1, reply.getPost_idx());
			pstmt.setString(2, reply.getName());
			pstmt.setString(3, reply.getEmail());
			pstmt.setString(4, reply.getPasswd());
			pstmt.setInt(5, reply.getReply_order());
			pstmt.setAsciiStream(6, is, size);
			pstmt.setString(7, reply.getW_ip());
			//pstmt.setTimestamp(5, reply.getW_time());
			pstmt.executeUpdate();
			pstmt.close();

			// forum_post의 conn_postcnt와 w_time컬럼의 값을 변경한다.
			pstmt = (PreparedStatement) conn
					.prepareStatement("update forum_post set conn_postcnt=conn_postcnt+1, w_time=? where p_id="
							+ reply.getPost_idx());
			pstmt.setTimestamp(1, reply.getW_time());
			pstmt.executeUpdate();

		} catch (SQLException e) {
			e.printStackTrace();
			throw new ForumCtrl_Exception(ForumCtrl_Exception.WRITE_CONTENT,
					"내용을 추가하는 과정에서 예외 발생");
		} finally {
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException e) {
					System.err
							.println("Exception :: ForumCtrl.java: writeReply(ForumReplyBean): stmt.close() 실행중 예외발생");
				}

			}
			if (pstmt != null) {
				try {
					pstmt.close();
				} catch (SQLException e) {
					System.err
							.println("Exception :: ForumCtrl.java: writeReply(ForumReplyBean): pstmt.close() 실행중 예외발생");
				}
			}
			if (conn != null) {
				dbCtrl.returnConnection(DBName, conn);
			}
		}
	}

	//리플 삭제
	public synchronized void deleteContent(int post_idx, int reply_order)
			throws ForumCtrl_Exception {
		ConnectionPoolCtrl dbCtrl = ConnectionPoolCtrl.getInstance();
		Connection conn = null;
		Statement stmt = null;

		try {
			conn = (Connection) dbCtrl.getConnection(DBName);
			stmt = conn.createStatement();
			int result = stmt
					.executeUpdate("delete from forum_reply where post_idx="
							+ post_idx + " and reply_order=" + reply_order);

			if (result > 0) {
				stmt
						.executeUpdate("update forum_reply set reply_order=reply_order-1 where post_idx="
								+ post_idx + " and reply_order>" + reply_order);
				stmt
						.executeQuery("update forum_post set conn_postcnt=conn_postcnt-1 where p_id="
								+ post_idx);
			}
		} catch (SQLException e) {
			e.printStackTrace();
			throw new ForumCtrl_Exception(ForumCtrl_Exception.DELETE_CONTENT,
					"글을 삭제하는 과정에서 예외 발생");

		} finally {
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException e) {
					System.err
							.println("Exception :: ForumCtrl.java: deleteContent(int, int): stmt.close() 실행중 예외발생");
				}

			}
			if (conn != null) {
				dbCtrl.returnConnection(DBName, conn);
			}
		}
	}
}
