/*
 * Created on Jul 28, 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package asr.web.db;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.Enumeration;
import java.util.Vector;

public class ConnectionPool {

	private int checkedOut;

	private Vector freeConnections = new Vector();

	private int maxConn;

	private String name;

	private String password;

	private String URL;

	private String user;

	public static final int DEFAULT_MAX_CON = 50;

	public synchronized void returnConnection(Connection conn) {
		// Connection을 vector의 맨 마지막에 삽입
		freeConnections.addElement(conn);
		checkedOut--;
		notifyAll();

	}

	public synchronized void close() {
		Enumeration allConnections = freeConnections.elements();
		while (allConnections.hasMoreElements()) {
			Connection conn = (Connection) allConnections.nextElement();
			try {
				conn.close();

			} catch (SQLException ex) {
				System.err.println("Wrng! close()");
			}

			freeConnections.removeAllElements();
		}

	}

	public synchronized Connection getConnection() {
		Connection conn = null;

		while(freeConnections.size() <= 0) {
			if (checkedOut < maxConn) {
				conn = newConnection();
				break;
			}

			try {
				// 저장되어 있는 컨넥션이 없을 경우 컨넥션이 반환될때까지 기다린다.
				wait();

			} catch (InterruptedException ex) {
				System.out.println("Wrng! getConnection()");
			}
		}

		if (conn == null) {
			try{
			conn = (Connection) freeConnections.firstElement();
			freeConnections.removeElementAt(0);
			} catch(Exception e)
			{
				
				System.err.println("Exception :: freeConnection.size() is "+freeConnections.size());
				System.err.println("Message :: checkedOut is "+checkedOut+" maxConn is "+maxConn);
			}

			try {
				if (conn.isClosed()) {
					conn = newConnection();

				}
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				// e.printStackTrace();
				System.out.println("Err! getConnection()");
			}
		}

		if (conn != null) {
			checkedOut++;
		}

		return conn;

	}

	private Connection newConnection() {
		// TODO Auto-generated method stub
		Connection conn = null;

		try {
			if (user == null) {
				conn = DriverManager.getConnection(URL);
			} else {
				
				conn = DriverManager.getConnection(URL, user, password);
			}
		} catch (SQLException e) {
			System.err.println("Exception :: ConnectionPool.java: newConnection() 에서 예외 발생");
			System.err.println("Message :: user is "+user+" URL is "+URL+ " password is "+password);
			//e.printStackTrace();
		}finally{
			if(conn == null){
				System.err.println("Message :: ConnectionPool.java: newConnection(): conn has null value");
				return null;
			}
		}
		return conn;
	}

	public ConnectionPool(String name, String URL, String user,
			String password, int maxConn) {
		this.name = name;
		this.URL = URL;
		this.user = user;
		this.password = password;
		this.maxConn = maxConn;

		if (this.maxConn <= 0) {
			this.maxConn = DEFAULT_MAX_CON;
		}
	}

	public static int getDEFAULT_MAX_CONN() {
		return DEFAULT_MAX_CON;
	}

	public int getCheckedOut() {
		return checkedOut;
	}

	public Vector getFreeConnections() {
		return freeConnections;
	}

	public int getMaxConn() {
		return maxConn;
	}

	public String getName() {
		return name;
	}

	public String getPassword() {
		return password;
	}

	public String getURL() {
		return URL;
	}

	public String getUser() {
		return user;
	}

	public void setCheckedOut(int checkedOut) {
		this.checkedOut = checkedOut;
	}

	public void setFreeConnections(Vector freeConnections) {
		this.freeConnections = freeConnections;
	}

	public void setMaxConn(int maxConn) {
		this.maxConn = maxConn;
	}

	public void setName(String name) {
		this.name = name;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public void setURL(String url) {
		URL = url;
	}

	public void setUser(String user) {
		this.user = user;
	}

}
