/*
 * Created on Jul 28, 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package asr.web.db;

import java.io.FileInputStream;
import java.sql.Connection;
import java.sql.Driver;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Properties;
import java.util.StringTokenizer;
import java.util.Vector;

public class ConnectionPoolCtrl {

	private static ConnectionPoolCtrl instance; // 유일한 인스턴스

	private Vector drivers = new Vector();

	private Hashtable pools = new Hashtable();

	public static synchronized ConnectionPoolCtrl getInstance() {
		if (instance == null) {
			instance = new ConnectionPoolCtrl();
		}
		return instance;
	}

	private ConnectionPoolCtrl() {
		init();
	}

	private void init() {
		// TODO Auto-generated method stub
		FileInputStream istream;
		Properties dbProps = new Properties();

		try {
			// 웹서버에 올릴때 파일 경로 수정할것.
			istream = new FileInputStream("/home/seungrye/public_html/DB.cfg");
			dbProps.load(istream);
			System.out.println("Message :: ConnectionPoolCtrl.java : init(): DB.cfg파일 읽기 성공");
		} catch (Exception e) {
			// 이 클래스가 있는 디렉토리에 DB설정파일을 가지고 있어야함
			System.err.println("Exception :: ConnectionPoolCtrl.java: init(): DB.cfg파일 읽기 예외발생");
			return;
		}

		loadJDBCDrivers(dbProps);
		
		System.out.println("Message :: ConnectionPoolCtrl.java: init(): createPools(dbProps)호출 ");
		createPools(dbProps);
	}

	private void loadJDBCDrivers(Properties dbProps) {
		// TODO Auto-generated method stub
		//String driverClasses = dbProps.getProperty("drivers",
			//	"org.gjt.mm.mysql.Driver");
		String  driverClasses = dbProps.getProperty("drivers");
		StringTokenizer token = new StringTokenizer(driverClasses);

		while (token.hasMoreElements()) {
			String driverClassName = token.nextToken().trim();
			System.out.println("Message :: ConnectionPoolCtrl.java: loadJDBCDrivers(Properties): SQL driver is "+driverClassName);
			try {
				Driver driver = (Driver) Class.forName(driverClassName)
						.newInstance();
				DriverManager.registerDriver(driver);
				drivers.addElement(driver);
			} catch (Exception e) {
				System.err.println("Wring! cant parsing DB.cgf file");
			}
		}
	}

	private void createPools(Properties dbProps) {
		// TODO Auto-generated method stub
		Enumeration propNames = dbProps.propertyNames();
		while (propNames.hasMoreElements()) {
			String name = (String) propNames.nextElement();
			if (name.endsWith(".url")) {
				String poolName = name.substring(0, name.lastIndexOf("."));
				String url = dbProps.getProperty(poolName + ".url");

				if (url == null)
					continue;

				String user = dbProps.getProperty(poolName + ".user", "root");
				String password = dbProps.getProperty(poolName + ".password",
						"");
				String maxconn = dbProps.getProperty(poolName + ".maxconn",
						"20");

				int max;

				try {
					max = Integer.valueOf(maxconn).intValue();
				} catch (NumberFormatException e) {
					max = 20;
				}

				ConnectionPool pool = new ConnectionPool(poolName, url, user,
						password, max);
				pools.put(poolName, pool);
				
				System.out.println("Message :: ConnectionPoolCtrl.java: createPools(Properties): .url is "
						+ url +" .user is "+user);
			}
		}
	}
	
	public Connection getConnection(String name)
	{
		ConnectionPool pool = (ConnectionPool)pools.get(name);
		
		if(pool != null)
		{
			return pool.getConnection();
		}
		
		return null;
	}

	public void returnConnection(String name, Connection con)
	{
		ConnectionPool pool = (ConnectionPool)pools.get(name);
		
		if(pool != null)
		{
			pool.returnConnection(con);
		}
	}
	
	public synchronized void close() {
		Enumeration allPools = pools.elements();
		
		while(allPools.hasMoreElements())
		{
			ConnectionPool pool = (ConnectionPool) allPools.nextElement();
			
			pool.close();
		}
		
		Enumeration allDrivers = drivers.elements();
		
		while(allDrivers.hasMoreElements())
		{
			Driver driver = (Driver) allDrivers.nextElement();
			
			try{
				DriverManager.deregisterDriver(driver);
			} catch(SQLException ex)
			{
				System.err.println("Wrng! close()");
			}
		}
	}
	
}
